/*
 * admin_del.c : Ժ
 * $Revision: 1.6 $
 * $Date: 1999/02/22 04:45:31 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "mytypes.h"
#include "rensou.h"
#include "mikoto.h"
#include "lock.h"

#include "global.h"
#include "md5.h"

#include "htmlio.h"

#include "util.h"
#include "nkf.h"

#define ENTRY_NUM 4
#define DUMP_SIZE (3*16+1)
#define LINE_SIZE (8+3+DUMP_SIZE)
#define HTTP_SCHEME		"http://"

#ifndef USE_SMTP
#define USE_SMTP 0
#endif /* USE_SMTP */

extern unsigned char admin_digest[];

FILE *write_to    ARGS((char *to, char *from, char *mail_srv));
int quit_writting ARGS((FILE *fp));


/*
 * HashMD5forAdmin : MD5 Ǻϥå
 */
static BOOL HashMD5forAdmin(szDelKey, digest)
	CONST char *szDelKey;
	unsigned char digest[16];
{
	MD5_CTX md5ctx;
	MD5Init(&md5ctx);
	MD5Update(&md5ctx, (char *)szDelKey, strlen(szDelKey)+1);
	MD5Final(digest, &md5ctx);

	return TRUE;
}
/*
 * Deletable : ǽɤ
 */
static BOOL Deletable(digest)
	CONST unsigned char digest[16];
{
	int i;
	for (i = 0; i < 16; i++) {
		if (digest[i] != admin_digest[i])
			return FALSE;
	}
	return TRUE;
}
#ifdef NOTDEF
/*
 * AddArticle : ĥʸ
 */
BOOL AddArticle(article, buf, length)
	char **article;
	CONST char *buf;
	int *length;
{
	char *sz;
	sz = (char *)realloc(*article, *length += strlen(buf));
	if (sz == NULL) {
		return FALSE;
	}
	*article = sz;
	strcat(*article, buf);
	return TRUE;
}
#endif
void print2mail(fp_in, fp_mail, number)
	FILE *fp_in, *fp_mail;
	int number;

{
	char *szServer, *szRemoteAddr, *szRemoteHost;
	int c;
	char buff[SMALL_BUFFER_SIZE];
	/* Mail إåν */
	fprintf(fp_mail,
			"Subject: A message (#%08d) has just been deleted.\n",
			number);
	fprintf(fp_mail, "From: Mikoto <%s>\n", ADMIN_EMAIL);
	fprintf(fp_mail, "\n");

	/* CGI ưƤ륵 */
	fputs("ߤȤ顤ԺΤΤ餻Ǥ\n\n", fp_mail);
	fputs("줿\n", fp_mail);

	if ((szServer = getenv("SERVER_NAME")) != NULL) {
		fprintf(fp_mail, "CGI ưƤ륵: %s\n", szServer);
	}
	/* ⡼ȥɥ쥹(IP) */
	if ((szRemoteAddr = getenv("REMOTE_ADDR")) != NULL) {
		fprintf(fp_mail, "Ժ¹Ԥ桼Υ⡼ȥɥ쥹: %s\n",
				szRemoteAddr);
		
	}
	/* ⡼ȥۥ̾ */
	if ((szRemoteHost = getenv("REMOTE_HOST")) != NULL) {
		strcpy(buff, szRemoteHost);
	} else {
		IPtoHostName(buff, szRemoteAddr);
	}
	fprintf(fp_mail, "Ժ¹Ԥ桼Υ⡼ȥۥ: %s\n",
			buff);
	
	/* 줿å */
	fputs("\n줿å\n", fp_mail);
	fprintf(fp_mail, "ֹ: %08d\n", number);
	fputs("---------------- deleted message ----------------\n",
		  fp_mail);
	
	while ((c = getc(fp_in)) != EOF) {
		putc(c, fp_mail);
	}
	fputs("\n---------------- deleted message ----------------\n\n",
		  fp_mail);
}
/*
 * SendMail : Ԥ
 */
BOOL SendMail(fp, number)
	FILE *fp;
	int number;
{
	int fd[2];
	int pid;
	
	if (pipe(fd) == ERR) {
		return FALSE;
	}
	if ((pid = fork()) == 0) {
		FILE *mail_pipe, *fp_in;
#if !USE_SMTP
		char buff[SMALL_BUFFER_SIZE];
#endif
		
		close(fd[1]);
#if !USE_SMTP
		sprintf(buff, "%s %s", SENDMAIL_PATH, ADMIN_EMAIL);
		mail_pipe = popen(buff, "w");
#else
		mail_pipe = write_to(ADMIN_EMAIL, ADMIN_EMAIL, MAIL_SRV);
#endif
		if (mail_pipe == NULL) {
			exit(EXIT_FAILURE);
		}
		if ((fp_in = fdopen(fd[0], "r")) == NULL) {
			exit(EXIT_FAILURE);
		}
		nkfAssumeInputCode(NKF_EUC);
		nkfSetOutputCode(NKF_JIS);
		nkfToFile(fp_in, mail_pipe);
		
#if !USE_SMTP
		pclose(mail_pipe);
#else
		if (quit_writting(mail_pipe) != 0)
			return FALSE;
#endif
		fclose(fp_in);
		exit(EXIT_SUCCESS);
	} else if (pid > 0) {
		FILE *fp_out;
		int stat_loc;
		
		close(fd[0]);
		if ((fp_out = fdopen(fd[1], "w")) == NULL) {
			return FALSE;
		}
		print2mail(fp, fp_out, number);
		fclose(fp_out);
		wait(&stat_loc);
	} else {
		return FALSE;
	}
	return TRUE;
}
/*
 * admindel: Ժ
 */
BOOL admindel()
{
	char *szDelKey, *szDelNum;
	unsigned char digest[16];
	int iNum;
	char sz[SMALL_BUFFER_SIZE];

	/* « */
	printf("\n");
	StartHtml("", READ_PATH, REFRESH_SEC);
	fflush(stdout);
	if (!CheckReferer(ADMIN_HTML_NAME)) {
		EndHtml();
		return FALSE;
	}

	/* ȤäƤʤǧ*/
	szDelKey = GetRensou(g_FormDatas, DEL_ADMINKEY_ENTRY);
	if (szDelKey != NULL) {
		if (strcmp(szDelKey, "") == 0) {
			KuhakuUmeteHtml(PEKORI_FACE, "");
			return FALSE;
		}
	} else {
		printf("߼ԤǤ<br>\n");
		return FALSE;
	}
	szDelNum = GetRensou(g_FormDatas, DEL_NUM_ENTRY);
	if (szDelNum != NULL) {
		if (strcmp(szDelNum, "") == 0) {
			KuhakuUmeteHtml(PEKORI_FACE, "ֹ");
			return FALSE;
		}
	} else {
		printf("߼ԤǤ<br>\n");
		return FALSE;
	}
	if (sscanf(szDelNum, "%d", &iNum) == EOF) {
		printf("ֹ椬Ǥ<br>\n");
		return FALSE;
	}
	HashMD5forAdmin(szDelKey, digest);

	if (Deletable(digest)) {
		char Mes[64];
		FILE *fp;

		sprintf(Mes, "%s/%08d", MES_DIR_NAME, iNum);
		if ((fp = fopen(Mes, "r+")) == NULL) {
			ErrorHtml(ERROR_FACE, "fopen() ؿǼԤޤ");
			return FALSE;
		}
		
		if (!SendMail(fp, iNum)) {
			ErrorHtml(ERROR_FACE, "Ԥ e-mail ޤ");
			return FALSE;
		}
		if ((fp = freopen(Mes, "w", fp)) == NULL) {
			ErrorHtml(ERROR_FACE, "freopen ˼Ԥޤ");
			return FALSE;
		}
		fprintf(fp, "Erase\n");
		
		sprintf(sz, "%d ֤Υåκޤ", iNum);
		KekkaHtml(sz);

		fflush(stdout);
		fclose(fp);
		DestroyCache(CACHE_FILE_NAME);
	
	} else
		ErrorHtml(ERROR_FACE,
				  "åǤޤǤְäƤǽޤ");
	
	return TRUE;
}
