/*
 * catmes.c : 񤭹ߤ HTML ɽ
 * $Revision: 1.6.1.1 $
 * $Date: 1999/03/02 12:29:34 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <signal.h>

#include "mytypes.h"
#include "rensou.h"
#include "mikoto.h"
#include "htmlio.h"
#include "cookie.h"
#include "util.h"

#define max(a, b)		(((a) > (b)) ? (a) : (b))
#define IN 0
#define OUT 1
#ifndef CACHE_FILE_NAME
#define CACHE_FILE_NAME "cache.html"
#endif

time_t g_modified_time;

/*
 * cat : å HTML ǽ
 */
BOOL cat(iPrev, iArticleNum, fp_out)
	int iPrev;
	int iArticleNum;
	FILE *fp_out;
{
    FILE *fpMesCount;
	char szCount[16];
	int iCount = 0;
	int iMinArticle;
	
	if ((fpMesCount = fopen(MES_COUNT_FILE_NAME, "r")) == NULL) {
		printf("%s Can't open count file. \n", MES_COUNT_FILE_NAME);
		return FALSE;
	}
	fgets(szCount, 16, fpMesCount);
	fclose(fpMesCount);
	
	iCount = atoi(szCount);

	if (iPrev != -1)
		iCount = max(iCount-iPrev, 0);
	
	if (iArticleNum != -1)
		iMinArticle = max(iCount-iArticleNum, 0);
	else
		iMinArticle = iCount;

	do {
		char szFilename[64];
		char sz1stLine[16];
		FILE *fp;
		
		sprintf(szFilename, "%s/%08d", MES_DIR_NAME, iCount);

		if ((fp = fopen(szFilename, "r")) == NULL) 
			continue;

		if (fgets(sz1stLine, 16, fp) == NULL) {
			puts("<strong>եɤ߹ߤ˼Ԥޤ</strong><br>");
			fclose(fp);
			continue;
		}
		if (strcmp(sz1stLine, "Erase\n") == 0) {
			fclose(fp);
			continue;
		}
		
		/* ġΥƥɽ */
		PrintArticle(iCount, fp_out, fp);
		PrintForm(FOLLOW_PATH,
				  iCount, max(iPrev-DISPLAY_ARTICLE_NUM, 0),
				  fp_out);

		fclose(fp);
		
		fputs("<hr>\n", fp_out);
		
	} while (--iCount > iMinArticle);
	return TRUE;
}
/*
 * sig_catcher() : ǻˡå˲롣
 */
void sig_catcher()
{
	int fd;
	fd = open(CACHE_FILE_NAME, O_CREAT | O_TRUNC | O_WRONLY);
	close(fd);
	puts("<p><strong>餫ͳǤޤ</strong></p>");
	exit(1);
}
BOOL write_stdout_and_cache(iPrev, iArticleNum)
	int iPrev;
	int iArticleNum;
{
	int fd[2];
	int pid;
	if (pipe(fd) == ERR) {
		return FALSE;
	}
	fflush(stdout);
	if ((pid = fork()) == 0) {
		FILE *fp_out;
		close(fd[IN]);
		if ((fp_out = fdopen(fd[OUT], "w")) == NULL) {
			exit(1);
		}
		cat(iPrev, iArticleNum, fp_out);
		fclose(fp_out);
		exit(0);
	} else if (pid > 0) {
		FILE *fp_cache, *fp_in;
		char buff[SMALL_BUFFER_SIZE];
		size_t size;
		close(fd[OUT]);
		if ((fp_in = fdopen(fd[IN], "r")) == NULL) {
			close(fd[IN]);
			return FALSE;
		}
		
		if ((fp_cache = fopen(CACHE_FILE_NAME, "w")) == NULL) {
			return FALSE;
		}
		signal(SIGQUIT, sig_catcher);
		signal(SIGINT, sig_catcher);
		signal(SIGTERM, sig_catcher);
		while ((size = fread(buff, 1, SMALL_BUFFER_SIZE, fp_in)) > 0) {
			if (fwrite(buff, 1, size, fp_cache) < size ||
				fwrite(buff, 1, size, stdout) < size) {
				fclose(fp_cache);
				fclose(fp_in);
				sig_catcher();
			}
		}
		fclose(fp_cache);
		fclose(fp_in);
	} else {
		return FALSE;
	}
	return TRUE;
}
/*
 * print_input_field : text եɤ򡢥åͤƽ
 */
void print_input_field(entry, value, col)
	CONST char *entry, *value; int col;
{
	if (value == NULL) {
		value = "";
	}
	printf("<input type=\"text\" name=\"%s\" value=\"%s\" size=\"%d\">",
		   entry, value, max(strlen(value), col));
	return ;

}
/*
 * MakeQuoteText: ʸ
 */
void MakeQuoteText(quote, value, quote_symbol)
	char *quote, *value;
	CONST char *quote_symbol;
{
	char c;
	
	strcpy(quote, quote_symbol);
	quote += strlen(quote_symbol);
	while ((c = *value++) != '\0') {
		switch (c) {
		case '<':
			while ((c = *value++) == ' ' || c == '\t')
				;
			if (toupper(c) == 'B' &&
				toupper(*value) == 'R') {
				*quote++ = '\n';
				strcpy(quote, quote_symbol);
				quote += strlen(quote_symbol);
			}
			while ((c = *value++) != '>' && c != '\0')
					;
			break;
		case '&':
			if (strncmp(value, "gt;", 3) == 0) {
				*quote++ = '>';
				value += 3;
			} else if (strncmp(value, "lt;", 3) == 0) {
				*quote++ = '<';
				value += 3;
			} else if (strncmp(value, "amp;", 4) == 0) {
				*quote++ = '&';
				value += 4;
			} else if (strncmp(value, "quot;", 5) == 0) {
				*quote++ = '\"';
				value += 5;
			} else {
				*quote++ = *value++;
			}
			break;
		case '\n':
			break;
		default:
			*quote++ = c;
			break;
		}
	}
	*quote = '\0';
}
/*
 * print_contents_area: ʸʸ롣
 */
void print_contents_area(entry, author, value, rows, cols)
	CONST char *entry, *author, *value; int rows, cols;
{
	char *quote = NULL;
	if (value == NULL) {
		value = "";
	} else if ((quote = malloc(strlen(value)+1)) != NULL) {
		MakeQuoteText(quote, value, ">");
	}
	printf("<textarea name=\"%s\" rows=\"%d\" cols=\"%d\" wrap=\"off\">\n",
		   entry, rows, cols);
	if (author != NULL) {
		printf("%sϤä㤤ޤ\n", author);
	}
	if (quote != NULL) {
		printf("%s", quote);
	}
	printf("</textarea>\n");
	if (quote != NULL) {
		free(quote);
	}
}
/*
 * GetMode : HTML Ȥϥ⡼ɤ
 */
CONST char *GetMode(sz, mode)
	CONST char *sz; char *mode;
{
	CONST char *new_pos;
	if (strncmp(sz, "<!--#", strlen("<!--#")) != 0) {
		*mode = '\0';
		return sz;
	}
	new_pos = sz+strlen("<!--#");
	while (*new_pos == ' ') new_pos++;
	while (*new_pos != ' ' && *new_pos != '-' && *new_pos != '\0') {
		*mode++ = *new_pos++;
	}
	*mode = '\0';
	
	while (*new_pos != '>' && *new_pos != '\0')
		new_pos++;

	return (*new_pos != '\0') ? new_pos+1 : new_pos;
}
void print_cache()
{
	FILE *fp;
	int size;
	char *buff[SMALL_BUFFER_SIZE];
	if ((fp = fopen(CACHE_FILE_NAME, "r")) == NULL) {
		return;
	}
	while ((size = fread(buff, 1, SMALL_BUFFER_SIZE, fp)) > 0) {
		fwrite(buff, 1, size, stdout);
	}
	fclose(fp);
}
/*
 * output : <!--#output--> ʬˡåɽ
 *          ʤɤɽ
 */
BOOL output(szNum, cat_current)
	CONST char *szNum; BOOL cat_current;
{
	int iPrev = 0;
	BOOL rc = TRUE;
	CONST char *szMikotoName = NULL;
	
	if (cat_current) {
		struct stat cache_stat;
		time_t cache_time;
		if (stat(CACHE_FILE_NAME, &cache_stat) == ERR) {
			rc = write_stdout_and_cache(-1, DISPLAY_ARTICLE_NUM);
		} else {
			cache_time =  cache_stat.st_mtime;
			if (cache_time > g_modified_time && cache_stat.st_size > 0) {
				print_cache();
			} else {
				rc = write_stdout_and_cache(-1, DISPLAY_ARTICLE_NUM);
			}
		}
	} else {
		iPrev = atoi(szNum);
		rc = cat(iPrev, DISPLAY_ARTICLE_NUM);
	}
					
	printf("<form method=\"post\" action=\"%s\">\n", READ_PATH);
	puts("<input type=\"submit\" value=\"ΤΤɽ\">");
	printf("<input type=\"hidden\" name=\"%s\" value=\"catmes\">\n",
		   MODE_ENTRY);
	printf("<input type=\"hidden\" name=\"prev\" value=\"%d\">\n",
		   iPrev+DISPLAY_ARTICLE_NUM);
	puts("</form>");
	puts("<hr>");
	/* ɽ (äʤǤ)*/
	printf("<p align=\"right\">");
	printf("<img src=\"../%s\" alt=\"(^_^)\" width=\"40\" height=\"30\">",
		   NORMAL_FACE);
	if ((szMikotoName = strrchr(g_szCGIName, '/')) == NULL) {
		szMikotoName = g_szCGIName;
	} else {
		szMikotoName += 1;
	}
	printf("<strong>ߤ.cgi/%s %s</strong><br>",
		   szMikotoName, MIKOTO_VER);
	printf("<strong>%s</strong>", MIKOTO_COPYRIGHT);
	/* ޤ */
	puts("</p><hr>");
	
	return rc;
}
/*
 * ReadFormHtml: Ȥʤ HTML եɤ߹ߡ
 */
char *ReadFormHtml(size)
	size_t *size;
{
	FILE *fp;
	char *form_html;
	struct stat stbuf;
	
	if ((fp  = fopen(FORM_HTML_NAME, "r")) == NULL) {
		ErrorHtml(ERROR_FACE, "ե򥪡ץǤޤǤ");
		return NULL;
	}
	if (fstat(fileno(fp), &stbuf) == ERR) {
		ErrorHtml(ERROR_FACE, "form.html ΥåǼԤޤ");
		return NULL;
	}
	if ((form_html = malloc(stbuf.st_size+1)) == NULL) {
		ErrorHtml(ERROR_FACE, "γƤǼԤޤ");
		return NULL;
	}
	*(form_html+stbuf.st_size) = '\0';
    if (fread(form_html, 1, stbuf.st_size, fp) < stbuf.st_size) {
		ErrorHtml(ERROR_FACE, "form.html ɤ߹ߤǼԤޤ");
		return NULL;
	}
	fclose(fp);
	*size = stbuf.st_size;
	return form_html;
}
/*
 * last_modified_header: ǽ񤭹߻򡢥إåΤ餻롣
 */ 
void last_modified_header()
{
	struct stat count_stat;
	if (stat(MES_COUNT_FILE_NAME, &count_stat) != ERR) {
		g_modified_time = count_stat.st_mtime;
		printf("Last-Modified: %s\n", asctime_rfc1123(&g_modified_time));
		puts("Pragma: no-cache");
		printf("Expires: %s\n", asctime_rfc1123(&g_modified_time));
	}
}
/*
 * catmes : å and ɽѲ̤ form.html 򻲹ͤˤƽ
 */
BOOL catmes(cat_current, follow)
	BOOL cat_current, follow;
{
	RENSOU AllCookies[ALL_COOKIE_NUM];
	char *form_html = NULL;
	CONST char *pkakko;
	char *szAddress, *szName, *szDelKey;
	char *szRefAuth = NULL, *szSubject = NULL,
		*szRef = NULL, *szContents = NULL;
	BOOL use_cookie;
	BOOL rc = TRUE;
	size_t size;
	
	last_modified_header();

	puts("");

	/* åμ */
	use_cookie = RecvCookies(AllCookies, ALL_COOKIE_NUM);
	if (use_cookie) {
		szAddress = GetRensou(AllCookies, ADDRESS_ENTRY);
		szName = GetRensou(AllCookies, NAME_ENTRY);
		szDelKey = GetRensou(AllCookies, DELKEY_ENTRY);
	} else {
		szAddress = "";
		szName = "";
		szDelKey = "";
	}
	/* եѰʸ */
	if (follow) {
		int iRef;
		char szFilename[512];
		FILE *fref;
		iRef = atoi(GetRensou(g_FormDatas, "num"));
		sprintf(szFilename, "%s/%08d", MES_DIR_NAME, iRef);
		if ((fref = fopen(szFilename, "r")) != NULL) {
			ReadRefFile(&szRefAuth, &szSubject, &szRef, &szContents,
						iRef, fref);
			fclose(fref);
		}
	}
	/* form.html ɤ߹ */
	if ((form_html = ReadFormHtml(&size)) == NULL) {
		rc = FALSE;
		goto end;
	}
	/* եη */
	pkakko = form_html;
	while (pkakko < form_html+size) {
		char mode[SMALL_BUFFER_SIZE];
		
		if (*pkakko != '<') {
			printf("%c", *pkakko++);
			continue;
		}
		pkakko = GetMode(pkakko, mode);
		if (strcmp(mode, "output") == 0) {
			if (!(rc = output(GetRensou(g_FormDatas, "prev"), cat_current))) {
				continue;
			}
		} else if (strcmp(mode, "email") == 0) {
			print_input_field(ADDRESS_ENTRY, szAddress, ADDRESS_ENTRY_SIZE);
		} else if (strcmp(mode, "name") == 0) {
			print_input_field(NAME_ENTRY, szName, NAME_ENTRY_SIZE);
		} else if (strcmp(mode, "del_key") == 0) {
			print_input_field(DELKEY_ENTRY, szDelKey, DELKEY_ENTRY_SIZE);
		} else if (strcmp(mode, "subject") == 0) {
			print_input_field(SUBJECT_ENTRY, szSubject, SUBJECT_ENTRY_SIZE);
		} else if (strcmp(mode, "ref") == 0) {
			print_input_field(REFERENCE_ENTRY, szRef, REFERENCE_ENTRY_SIZE);
		} else if (strcmp(mode, "contents") == 0) {
			print_contents_area(CONTENTS_ENTRY,
								szRefAuth, szContents,
								CONTENTS_ENTRY_HEIGHT,
								CONTENTS_ENTRY_WIDTH);
		} else if (strcmp(mode, "link") == 0) {
			printf("<link rev=\"made\" href=\"%s\">\n", ADMIN_EMAIL);
		} else if (strcmp(mode, "cgi_ver") == 0) {
			printf("%s", MIKOTO_VER);
		} else if (*pkakko == '\0'){
			break;
		} else {
			printf("%c", *pkakko++);
		}
	}
	fflush(stdout);
	/*  */
end:	
	if (form_html != NULL) free(form_html);
	if (szRefAuth != NULL) free(szRefAuth);
	if (szSubject != NULL) free(szSubject);
	if (szRef != NULL) free(szRef);
	if (szContents != NULL) free(szContents);
	
	if (use_cookie) {
		FreeRensou(AllCookies, ALL_COOKIE_NUM);
	}
	return rc;
}
