/*
 * delmes.c : åؿ delmes() ȡdelmes() ƤФؿ
 * $Revision: 1.6 $
 * $Date: 1999/02/22 04:49:16 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "mytypes.h"
#include "rensou.h"
#include "mikoto.h"
#include "lock.h"

#include "global.h"
#include "md5.h"

#include "htmlio.h"
#include "nkf.h"

#define ENTRY_NUM 4
#define DUMP_SIZE (3*16+1)
#define LINE_SIZE (8+3+DUMP_SIZE)

/*
 * hashMD5 : MD5 Ǻϥå
 */
BOOL hashMD5(iNum, szDelKey, digest)
	int iNum;
	CONST char *szDelKey;
	unsigned char digest[16];
{
	MD5_CTX md5ctx;
	char buffer[SMALL_BUFFER_SIZE];
	int pid, fd1[2], fd2[2];

	if (pipe(fd1) == ERR) {
		return FALSE;
	}
	if (pipe(fd2) == ERR) {
		return FALSE;
	}
	if ((pid = fork()) == 0) {
		FILE *fp_in, *fp_out;
		close(fd1[FD_IN]);
		close(fd2[FD_OUT]);
		if ((fp_out = fdopen(fd1[FD_OUT], "w")) == NULL) {
			exit(EXIT_FAILURE);
		}
		if ((fp_in = fdopen(fd2[FD_IN], "r")) == NULL) {
			exit(EXIT_FAILURE);
		}
		
		nkfSetOutputCode(NKF_EUC);
		nkfAssumeHankakuKana(TRUE);
		nkfSetDelCR();
		nkfToFile(fp_in, fp_out);
		
		fclose(fp_out);
		fclose(fp_in);
		exit(EXIT_SUCCESS);
	} else if (pid > 0){
		FILE *fp_in, *fp_out;
		int i;
		int c;
		int stat_loc;
		
		close(fd1[FD_OUT]);
		close(fd2[FD_IN]);
		if ((fp_in = fdopen(fd1[FD_IN], "r")) == NULL) {
			return FALSE;
		}
		if ((fp_out = fdopen(fd2[FD_OUT], "w")) == NULL) {
			return FALSE;
		}
		fprintf(fp_out, "%d:%s", iNum, szDelKey);
		fclose(fp_out);
		for (i = 0; i < sizeof (buffer)-1; i++) {
			if ((c = getc(fp_in)) != EOF) {
				buffer[i] = c;
			} else {
				break;
			}
		}
		buffer[i] = '\0';
		fclose(fp_in);
		
		wait(&stat_loc);
	} else {
		return FALSE;
	}

	MD5Init(&md5ctx);
	MD5Update(&md5ctx, buffer, strlen(buffer)+1);
	MD5Final(digest, &md5ctx);

	return TRUE;
}
/*
 * Deletable : ͭåޤ
 */
BOOL Deletable(digest, iNum)
	unsigned char digest[16];
	int iNum;
{
	FILE *fp;
	char sLine[LINE_SIZE], dump[LINE_SIZE];
	int i;

	sprintf(dump, "%08d =", iNum);
	for (i = 0; i < 16; i++) 
		sprintf(dump, "%s %x", dump, digest[i]);
	sprintf(dump, "%s\n", dump);

	if ((fp = fopen(DELKEY_FILE_NAME, "r")) == NULL) {
		return FALSE;
	}
	while (fgets(sLine, LINE_SIZE, fp) != NULL) {
		if (strcmp(sLine, dump) == 0)
			return TRUE;
	}
	return FALSE;
}
/*
 * delmes : åκؿ
 */
BOOL delmes()
{
	char *pszDelKey, *pszDelNum;
	char Mes[64];
	unsigned char digest[16];
	int iNum;
	FILE *fp;
	
	printf("\n");
	StartHtml("", READ_PATH, REFRESH_SEC);
		
	/* ȤäƤʤǧ*/
	pszDelKey = GetRensou(g_FormDatas, DEL_DELKEY_ENTRY);
	if (pszDelKey != NULL) {
		if (strcmp(pszDelKey, "") == 0) {
			KuhakuUmeteHtml(PEKORI_FACE, "");
			return FALSE;
		}
	} else {
		printf("߼ԤǤ<br>\n");
		return FALSE;
	}
	/* μ */
	pszDelNum = GetRensou(g_FormDatas, DEL_NUM_ENTRY);
	if (pszDelNum != NULL) {
		if (strcmp(pszDelNum, "") == 0) {
			KuhakuUmeteHtml(PEKORI_FACE, "ֹ");
			return FALSE;
		}
	} else {
		puts("߼ԤǤ<br>\n");
		return FALSE;
	}
	/* ֹȤȤ߹碌 MD5 ǥϥå */
	iNum = atoi(GetRensou(g_FormDatas, DEL_NUM_ENTRY));
	hashMD5(iNum, GetRensou(g_FormDatas, DEL_DELKEY_ENTRY), digest);

	/* ǽɤ */
	if (!Deletable(digest, iNum)) {
		ErrorHtml(ERROR_FACE,
				  "åǤޤǤ򤬰ۤʤǽޤ");
		return FALSE;
	}
	
	/* ¹ */
	sprintf(Mes, "%s/%08d", MES_DIR_NAME, iNum);
	if ((fp = fopen(Mes, "w")) == NULL) {
		ErrorHtml(ERROR_FACE, "fopen ǼԤޤ");
		return FALSE;
	}
	fprintf(fp, "Erase\n");
	KekkaHtml("ޤ");


	fclose(fp);
	fflush(stdout);
	
	DestroyCache(CACHE_FILE_NAME);

	return TRUE;
}
