/*
 * generate_adminkey.c : Ժѥ
 * Copyright (C) 1998 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef linux
#include <bsd/sgtty.h>
#else
#include <sgtty.h>
#endif
#include <signal.h>

#include "mytypes.h"
#include "global.h"
#include "md5.h"

#define min(x, y) ((x) < (y) ? (x) : (y))
#define BUFF_SIZE  64

struct sgttyb tbufin;
short prev_sg_flags = 0;

char *rindex();

void recv_string(buff)
	char buff[];
{
	int c, i;
	
	for (i = 0; (c = getchar()) != EOF && i < BUFF_SIZE; i++) {
		if (c == '\n' || c == '\r') {
			break;
		}
		buff[i] = c;
	}
	buff[min(i, BUFF_SIZE-1)] = '\0';
}
void echo_off()
{
	tbufin.sg_flags = CBREAK;
	if (ioctl(0, TIOCSETP, &tbufin) == ERR) {
		perror("ioctl");
		exit(EXIT_FAILURE);
	}
}
void echo_on()
{
	tbufin.sg_flags = prev_sg_flags;
	if (ioctl(0, TIOCSETP, &tbufin) == ERR) {
		perror("ioctl");
		exit(EXIT_FAILURE);
	}
}
void MD5hash(admin_key, digest)
	unsigned char *admin_key; unsigned char digest[];
{
	MD5_CTX context;
	
	MD5Init(&context);
	MD5Update(&context, admin_key, strlen(admin_key)+1);
	MD5Final(digest, &context);
}
void output_digest(filename, digest)
	char *filename; unsigned char digest[];
{
	int i;
	FILE *fp;

	fp = fopen(filename, "w");
	if (fp == NULL) {
		perror("fopen");
		return;
	}
	fprintf(fp, "unsigned char admin_digest[] = {\n");
	for (i = 0; i < 4; i++) {
		fprintf(fp, "\t0x%02x, 0x%02x, 0x%02x, 0x%02x, \n",
			   digest[i*4], digest[i*4+1], digest[i*4+2], digest[i*4+3]);
	}
	fprintf(fp, "};\n");
	
	if (fclose(fp) != 0) {
		perror("fclose");
		return;
	}
}
void usage(command_name)
	char *command_name;
{
	fprintf(stderr, "Usage: %s file\n", command_name);
	exit(EXIT_FAILURE);
}
void aborting()
{
	echo_on();
	exit(EXIT_FAILURE);
}
int main(argc, argv)
	int argc; char *argv[];
{
	char admin_key[BUFF_SIZE], one_more[BUFF_SIZE];
	unsigned char digest[16];
	char *command_name;
	
	if ((command_name = rindex(argv[0], '/')) != NULL) {
		command_name++;
	} else {
		command_name = argv[0];
	}
	
	if (argc < 2) {
		usage(command_name);
	}
	printf("Admin-key: ");
	fflush(stdout);
	if (ioctl(0, TIOCGETP, &tbufin) == ERR) {
		perror("ioctl");
		exit(EXIT_FAILURE);
	}
	prev_sg_flags = tbufin.sg_flags;
	if (signal(SIGINT, aborting) == SIG_ERR) {
		perror("signal");
		aborting();
		exit(EXIT_FAILURE);
	}
	
	echo_off();
	recv_string(admin_key);
	do {
		echo_on();
		printf("\nOne more please :");
		fflush(stdout);
		echo_off();
		recv_string(one_more);
	} while (strcmp(admin_key, one_more) != 0);
	echo_on();

	printf("\n");
	MD5hash(admin_key, digest);
	output_digest(argv[1], digest);

	return 0;
}
