/*
 * htmlio.c : HTML Ǥޤޤʽϴؿ
 * $Revision: 1.6 $
 * $Date: 1999/02/22 04:49:16 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "mytypes.h"
#include "htmlio.h"

#define SMALL_BUFF_SIZE 1024
#define LINE_LENGTH 1024

/*
 * StartHtml: HTML Ƭʬ
 */
void StartHtml(szTitle, szURL, iSec)
	CONST char* szTitle, *szURL;
	int iSec;
{
	puts("");
	puts(HTML_DTD);
	puts("<html>");
	puts("<head>");
	printf(HTML_REFRESH, iSec, szURL);
	printf("<title>%s</title>\n", szTitle);
	puts("</head>");
	puts("<body>");
}
/*
 * EndHtml: HTML Τʬ
 */
void EndHtml()
{
	puts("</body>");
	puts("</html>");
	fflush(stdout);
}
/*
 * KekkaHtml: ̤
 */
void KekkaHtml(Kekka)
	CONST char *Kekka;
{
	puts("<h2>𤷤ޤ</h2>");
	printf("<strong>%s</strong><br>", Kekka);
}
/*
 * ErrorHtml: 顼(˥饤֥ؿΥ顼)
 */
void ErrorHtml(Face, Error)
	CONST char *Face, *Error;
{
	printf("<img src=\"../%s\" alt=\"m(._.)m\" width=\"40\" height=\"30\">",
		   Face);
	puts("<h2>ȥ֥뤬ȯƤޤޤޤʤǰդǤ</h2>");
	printf("<strong>%s</strong>", Error);
	if (errno != 0) {
		printf(" : %d", errno);
	}
	printf("<br>\n");
}
/*
 * ShippaiHtml: HTML ǹԤ
 */
void ShippaiHtml(Face, Error)
	CONST char *Face, *Error;
{
	printf("<img src=\"../%s\" alt=\"(o)\" width=\"40\" height=\"30\">",
		   Face);
	puts("<h2>CGI ǥȥ֥뤬ȯƤޤޤޤʤǰդǤ</h2>");
	printf("<strong>%s</strong>\n", Error);
}
/*
 * OnegaiHtml: ꤤ HTML Ǥʤ
 */
void OnegaiHtml(Face, Title, Message)
	CONST char *Face, *Title, *Message;
{
	printf("<h2>");
	printf("<img src=\"../%s\" alt=\"m(._.)m\" width=\"40\" height=\"30\">",
		   Face);
	printf(" %s</h2>\n", Title);
	printf("<p>%s </p>", Message);
}
/*
 * KuhakuUmeteHtml : ɬܥեɤƤʤ
 */
void KuhakuUmeteHtml(Face, Field)
	CONST char *Face, *Field;
{
	puts("<h2>ʲΥեɤǤ</h2>");
	printf("<strong>%s</strong><br><br>\n", Field);
	puts("ơ٤񤭹߲");
	printf("<img src=\"../%s\" alt=\"m(._.)m\" width=\"40\" height=\"30\"><br>", Face);
}
/*
 *  GetHeader : HTTP or åեΥإå롣
 */
char *GetHeader(pHeader, pszName)
	HEADER *pHeader; char *pszName;
{
	while(pHeader->pName != NULL) {
		if (strcmp(pHeader->pName, pszName) == 0) {
			return pHeader->pValue;
		}
		pHeader++;
	}
	return NULL;
}
/*
 * FreeHeader: Ϣ
 */
void FreeHeaders(pHeader)
	HEADER *pHeader;
{
	HEADER *pCurHeader = pHeader;
	while (pCurHeader->pName != NULL) {
		free(pCurHeader->pName);
		free((pCurHeader++)->pValue);
	}
}
/*
 * SetHeaders: إåѿ
 */
BOOL SetHeaders(pHeader, szLine)
	HEADER *pHeader;
	char *szLine;
{
	char *kugiri;
	if ((kugiri = strchr(szLine, ':')) != NULL) {
		char *eol;
		*kugiri++ = '\0';
		
		pHeader->pName = (char *)malloc(strlen(szLine)+1);
		if (pHeader->pName == NULL) {
			return FALSE;
		}
		pHeader->pValue = (char *)malloc(strlen(kugiri)+1);
		if (pHeader->pValue == NULL) {
			return FALSE;
		}
		strcpy(pHeader->pName, szLine);
		strcpy(pHeader->pValue, kugiri);
		if ((eol = strchr(pHeader->pValue, '\n')) != NULL) 
			*eol = '\0';
	}
	return TRUE;
}
/*
 * SaveHeaders : ե뤫顢Ϣ˵
 */
BOOL SaveHeaders(fp, pHeaders, iNum)
	FILE *fp;
	HEADER *pHeaders;
	int iNum;
{
	char buff[SMALL_BUFF_SIZE];
	char c;

	while ((c = getc(fp)) == '\n')
		;
	ungetc(c, fp);
	
	while (fgets(buff, SMALL_BUFF_SIZE, fp) != NULL && iNum > 0) {
		if (strcmp(buff, "\n") == 0) {
			break;
		}
		if (!SetHeaders(pHeaders++, buff)) {
			return FALSE;
		}
		iNum--;
	}
	pHeaders->pName = NULL;
	return TRUE;
}
/*
 * PrintRow : ָФ:͡פȤǡԤɽ
 */
void PrintRow(fout, title, value)
	FILE *fout;
	CONST char *title, *value;
{
	fputs("<tr>", fout);
	fprintf(fout, "<th align=\"right\">%s:</th>\n", title);
	fprintf(fout, "<td>%s</td>", value);
	fputs("</tr>\n", fout);
}
/*
 * PrintReferenceURL :  URL 򡤥󥯤ɽ
 */
void PrintReferenceURL(url, fout)
	char *url; FILE *fout;
{
	int i;
	if (url == NULL) {
		return;
	}
	fputs("<blockquote>", fout);
	fputs("<p><strong> URL:</strong> <a href=\"", fout);
	for (i = 0; url[i] != '\0'; i++) {
		switch (url[i]) {
		case '~':
			fputs("%7E", fout);
			break;
		default:
			fputc(url[i], fout);
			break;
		}
	}
	fprintf(fout, "\">%s</a></p>\n", url);
	fputs("</blockquote>", fout);
}
/*
 * PrintArticle : ̤ȯĽϤ롣
 */
BOOL PrintArticle(iCount, fout, fp)
	int iCount;
	FILE *fout, *fp;
{
	HEADER Headers[HEADER_NUM];
	char buff[LINE_LENGTH];
	CONST char *address;
	int c;

	if (!SaveHeaders(fp, Headers, HEADER_NUM)) {
		return FALSE;
	}

	fputs("<table>\n", fout);
	
	/* ֹ */
	sprintf(buff, "<a name=\"%d\">%08d</a>", iCount, iCount);
	PrintRow(fout, "ȯֹ", buff);

	/* ɽ */
	sprintf(buff, "<strong>%s</strong>", GetHeader(Headers, "Subject"));
	PrintRow(fout, "ɽ", buff);
	
	/*  */
	if ((address = GetHeader(Headers, "Address")) != NULL) {
		if (*address != '\0') {
			sprintf(buff,
					"%s <code>&lt;<a href=\"mailto:%s\">%s</a>&gt;</code>",
					GetHeader(Headers, "Name"),	address, address);
		} else {
			sprintf(buff, "%s", GetHeader(Headers, "Name"));
		}
	} else {
		sprintf(buff, "%s", GetHeader(Headers, "Name"));
	}
	PrintRow(fout, "", buff);
	/*  */
	if (GetHeader(Headers, "Reference") != NULL) {
		sprintf(buff, "<a href=\"#%s\">%s </a>",
			   GetHeader(Headers, "Reference"),
			   GetHeader(Headers, "Reference"));
		PrintRow(fout, "", buff);
	}
	/*  */
	PrintRow(fout, "", GetHeader(Headers, "Date"));
	fputs("</table>\n", fout);
	
	/* ʸ */
	fputs("<blockquote><pre>", fout);
	putc(' ', fout);
	while ((c = getc(fp)) != EOF){
		if (c != '\n') {
			putc(c, fout);
		} else {
			putc(' ', fout);
		}
	}
	fputs("</pre></blockquote>\n", fout);
	PrintReferenceURL(GetHeader(Headers, "Reference-URL"), fout);
	
	fflush(fout);

	FreeHeaders(Headers);

	return TRUE;
}
/*
 * PrintForm: Ⱥѥեܥ HTML 
 */
void PrintForm(action, iCount, iPrev, fout)
	CONST char *action;
	int iCount, iPrev;
	FILE *fout;
{
	fprintf(fout, "<form action=\"%s\" method=\"post\">", action);
	fprintf(fout,
			"<input type=\"submit\" value=\"%d ֤˥Ȥ򤹤\">",
			iCount);
	fputs("<input type=\"hidden\" name=\"mode\" value=\"follow\">",
		  fout);
	fprintf(fout,
			"<input type=\"hidden\" name=\"num\" value=\"%d\">",
			iCount);
	fprintf(fout,
			"<input type=\"hidden\" name=\"prev\" value=\"%d\">",
			iPrev);
	fputs("</form>", fout);
}
/*
 * ReadRefFile: Ѥåʸ/ɽ/ֹʸȤƳǼ
 */
void ReadRefFile(ppName, ppSubject, ppRef, ppContents, iRef, fref)
	char **ppName, **ppSubject, **ppRef, **ppContents;
	int iRef;
	FILE *fref;
{
	HEADER Headers[HEADER_NUM];
	struct stat stbuf;
	int c;
	
	SaveHeaders(fref, Headers, HEADER_NUM);
	*ppName = malloc(strlen(GetHeader(Headers, "Name"))+1);
	if (*ppName != NULL) {
		strcpy(*ppName, GetHeader(Headers, "Name"));
	}
	*ppSubject = malloc(strlen(GetHeader(Headers, "Subject"))+4+1);
	if (*ppSubject != NULL) {
		CONST char *szSubject;
		szSubject = GetHeader(Headers, "Subject");
		if (strncmp(szSubject, "Re: ", 4) != 0) {
			sprintf(*ppSubject, "Re: %s", szSubject);
		} else {
			strcpy(*ppSubject, szSubject);
		}
	}
	*ppRef = malloc(8+1);
	if (*ppRef != NULL) {
		sprintf(*ppRef, "%d", iRef);
	}
	if (fstat(fileno(fref), &stbuf) != ERR) {
		int size;
		*ppContents = malloc(stbuf.st_size+1);
		if (*ppContents != NULL) {
			if ((size = fread(*ppContents, 1, stbuf.st_size, fref))
				 == 0) {
				free(*ppContents);
				*ppContents = NULL;
			} else {
				*(*ppContents+size) = '\0';
			}
		}
	}
	FreeHeaders(Headers);
}
