/*
 * $RCSfile: lock.c,v $ : եå
 * $Revision: 1.6 $
 * $Date: 1999/02/22 04:49:16 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>

#include "mytypes.h"
#include "lock.h"

#ifndef SIGALRM
#define SIGALRM		  14
#endif

/* timeoutޤǤλ */
#define ALARM_INTERVAL	10 

/* եϥɥȡեϥɥο */
static int g_hFiles[20], g_iHandleNum = 0;

/*
 *  WaitLockFile: åŬѤޤԤ
 */
void WaitLockFile(hFile)
	int hFile;
{
	struct flock lock;

	lock.l_type = F_WRLCK;
	lock.l_start = 0;
	lock.l_whence = SEEK_SET;
	lock.l_len = 0;

	fcntl(hFile, F_SETLK, &lock);
}
/*
 *  UnlockFiles: եΥå
 */
void UnlockFiles()
{
	struct flock lock;
	int j = 0;

	lock.l_type = F_UNLCK;
	lock.l_start = 0;
	lock.l_whence = SEEK_SET;
	lock.l_len = 0;
	for (j = 0; j < g_iHandleNum; j++){
		if (g_hFiles[j] != -1) {
			fcntl(g_hFiles[j], F_SETLK, &lock);
			close(g_hFiles[j]);
		}
	}
}
/*
 * UnlockFile : Ĥե򥢥å
 */
BOOL UnlockFile(fd)
	int fd;
{
	struct flock lock;
	int i;
	lock.l_type = F_UNLCK;
	lock.l_start = 0;
	lock.l_whence = SEEK_SET;
	lock.l_len = 0;
	
	for (i = 0; i < g_iHandleNum; i++){
		if (g_hFiles[i] == fd) {
			fcntl(g_hFiles[i], F_SETLK, &lock);
			close(g_hFiles[i]);
			g_hFiles[i] = -1;
			return TRUE;
		}
	}
	return FALSE;
}
/*
 *  SigAlarm: ॢȻν
 */
void SigAlarm(signo)
	int signo;
{
	UnlockFiles();
	
	/* timeoutν */
	puts("ޤ󡢥ॢȤƤޤޤ<br>");
}
/*
 *  LockFile: եΥå
 */
int LockFile(pszFileName, bEmpty, bAppend)
	char *pszFileName;
	BOOL bEmpty, bAppend;
{
	int iFlag;
	signal(SIGALRM, SigAlarm);
	alarm(ALARM_INTERVAL);
	if (bEmpty == TRUE)
		iFlag = O_WRONLY | O_CREAT | O_TRUNC;
	else {
		if (bAppend)
			iFlag = O_WRONLY | O_APPEND;
		else
			iFlag = O_WRONLY;
	}
	
	if ((g_hFiles[g_iHandleNum] = open(pszFileName, iFlag, 0600)) == ERR) {
		return -1;
	}
	
	WaitLockFile(g_hFiles[g_iHandleNum]);
	
	return g_hFiles[g_iHandleNum++];
}
/*
 * WRLockFile : Read/Write ξåեϥɥ֤
 */
int WRLockFile(pszFileName)
	char *pszFileName;
{
	signal(SIGALRM, SigAlarm);
	alarm(ALARM_INTERVAL);
	
	if ((g_hFiles[g_iHandleNum] = open(pszFileName, O_RDWR)) == ERR) {
		return -1;
	}
	
	WaitLockFile(g_hFiles[g_iHandleNum]);
	
	return g_hFiles[g_iHandleNum++];
}
