/*
 * ߤ.cgi
 * mikoto.c : Ǽ CGI Ρ񤭹ߴؿ
 * $Revision: 1.6.1.1 $
 * $Date: 1999/03/02 12:29:34 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <unistd.h>
#include <sys/time.h>
#include <signal.h>

#include "mytypes.h"
#include "rensou.h"
#include "mikoto.h"
#include "lock.h"
#include "cookie.h"
#include "htmlio.h"

#include "util.h"
#include "nkf.h"

#define max(a, b) ((a) > (b) ? (a) : (b))

/* DAY  */
#define DAY ((time_t)60L*60L*24L)

/* 󥵥 */
#define ENTRY_NUM		(16)

#ifndef CONTENT_LENGTH_MAX
#define CONTENT_LENGTH 0
#endif

#ifndef CHECK_OUTSIDE_FORM
#define CHECK_OUTSIDE_FORM 1
#endif /* CHECK_OUTSIDE_FORM */

#define HTTP_SCHEME		"http://"

/* CGI ϻ */
struct timeval g_date;

/*  CGI μ¹Ի̾ */
CONST char *g_szCGIName = NULL;

/* ե͡ */
char g_szMesName[16];
int g_iMesNum = 0;

/* ̾ e-mailɥ쥹  */
char *g_szName = NULL, *g_szAddress = NULL, *g_szDelKey = NULL;

/* Ķѿ CONTENT_LENGTH  */
int g_iContentLength = 0;

/* Cookie λ */
BOOL g_bUseCookie = FALSE;

/* λ */
BOOL g_bUseTag = FALSE;

/* եǡǼϢ */
RENSOU g_FormDatas[ENTRY_NUM];

static CONST char *g_szYoubi[] = {
	"", "", "", "", "", "", ""
};

/*
 * quitting : λθ
 */
void quitting()
{
	EndHtml();
	UnlockFiles();
	FreeRensou(g_FormDatas, ENTRY_NUM);

}
void quit()
{
	quitting();
	exit(1);
}
/*
 * PutNameEntity: ̤ʸϤΤޤޡüʸϡ͡२ƥ
 *                   ƥˤưԽϡ
 */
void PutNameEntity(str, fp)
	CONST char *str;
	FILE *fp;
{
	char c;
	while ((c = *str++) != '\0') {
		switch (c) {
		case '&':
			fputs("&amp;", fp);
			break;
		case '<':
			fputs("&lt;", fp);
			break;
		case '>':
			fputs("&gt;", fp);
			break;
		case '\"':
			fputs("&quot;", fp);
			break;
		case '\n':
			fputs("<br>\n", fp);
			break;
		default:
			putc(c, fp);
			break;
		}
	}
}
/*
 * PutLineHeader: إåեޥåȤ fp ˰Խϡ
 */
void PutLineHeader(fp, Header, Field)
	FILE *fp;
	CONST char *Header, *Field;
{
	fprintf(fp, "%s:", Header);
	PutNameEntity(Field, fp);
	putc('\n', fp);
}
/*
 * WriteArticle: åʸʬ
 */
void WriteArticle(str, fp)
	CONST char *str;
	FILE *fp;
{
	if (g_bUseTag) {
#if REPLACE_LF_TO_BRTAG
		while (*str != '\0') {
			if (*str != '\n') {
				putc(*str++, fp);
			} else {
				fputs("<br>\n", fp);
				str++;
			}
		}
#else
		fputs(str, fp);
#endif
	} else {
		PutNameEntity(str, fp);
	}
}
/*
 * CountEmptyLine : Ԥο롣
 */
int CountEmptyLine(str)
	CONST char *str;
{
	CONST char *crlf_head;
	int count = 0;
	
	crlf_head = str+strcspn(str, "\n");
	while (*crlf_head++ == '\n') {
		count++;
	}
	return count;
}
/*
 * SetOneCookie: HTTP  Set-Cookie إå
 */
void SetOneCookie(name, value, expires, domain)
	char *name, *value, *expires, *domain;
{
	printf("Set-Cookie: %s=%s; expires=%s; ", 
		   name, value, expires);
	if (domain != NULL)
		printf("domain=%s; " , domain);
	printf("\n");
}
/*
 * SendCookie: Cookie ֥饦
 */
BOOL SendCookies()
{
	char *pszEncName = NULL, *pszEncAddress = NULL, *pszEncDelKey = NULL;
	char *pszDomain;

	time_t Period;
	CONST char *szTimeForm;
	
	if ((pszEncName = (char *)malloc(strlen(g_szName)*3+1)) == NULL) {
		return FALSE;
	}
	URLEncode(pszEncName, g_szName);
	
	if (g_szAddress != NULL) {
		if ((pszEncAddress = (char *)malloc(strlen(g_szAddress)*3+1)) == NULL) {
			free(pszEncName);
			return FALSE;
		}
		URLEncode(pszEncAddress, g_szAddress);
	}
	if ((pszEncDelKey = (char *)malloc(strlen(g_szDelKey)*3+1)) == NULL) {
		free(pszEncName);
		free(pszEncAddress);
		return FALSE;
	}
	URLEncode(pszEncDelKey, g_szDelKey);
	
	Period = time(NULL)+DAY*EXPIRE_PERIOD;
	szTimeForm = asctime_for_cookie(&Period);
	pszDomain = getenv("SERVER_NAME");
	
	SetOneCookie(NAME_ENTRY, pszEncName, szTimeForm, pszDomain);
	
	if (pszEncAddress != NULL) {
		SetOneCookie(ADDRESS_ENTRY, pszEncAddress, szTimeForm, pszDomain);
	}
	SetOneCookie(DELKEY_ENTRY, pszEncDelKey, szTimeForm, pszDomain);
	
	free(pszEncName);
	free(pszEncAddress);
	free(pszEncDelKey);
	return TRUE;
}
/*
 * WriteRowText : åեޥåȤơfp_out ˽񤭹ࡣ
 */
void WriteRowText(pRensou, fp_out)
	CONST RENSOU *pRensou;
	FILE *fp_out;
{
	time_t timeNow;
	struct tm *pNowTime;
	char *curpos;
	CONST char *remote_addr;
	char buff[SMALL_BUFFER_SIZE];

	/* ԤƬ */
	putc('\n', fp_out);
	
	/* ߻ */
	time(&timeNow);
	pNowTime = localtime(&timeNow);
	strftime(buff, sizeof(buff), "Date:%Y %m/%d (%%s) %H:%M:%S\n", pNowTime);
	fprintf(fp_out, buff, g_szYoubi[pNowTime->tm_wday]);
	
	/* ޤΥإåĤ */
	if (g_szAddress != NULL)
		PutLineHeader(fp_out, "Address", g_szAddress);
	PutLineHeader(fp_out, "Name", g_szName);
	PutLineHeader(fp_out, "Subject", GetRensou(pRensou, SUBJECT_ENTRY));
	if ((remote_addr = getenv("REMOTE_ADDR")) != NULL) {
		PutLineHeader(fp_out, "RemoteAddr", remote_addr);
		IPtoHostName(buff, remote_addr);
		PutLineHeader(fp_out, "RemoteHost", buff);
	}
	
	/* 褬СΥإå */
	if (strcmp(GetRensou(pRensou, REFERENCE_ENTRY), "") != 0)
		PutLineHeader(fp_out, "Reference",
	/*  URL СΥإå */
					  GetRensou(pRensou, REFERENCE_ENTRY));
	if (strcmp(GetRensou(pRensou, REFERENCE_URL_ENTRY), "") != 0) {
		PutLineHeader(fp_out, "Reference-URL", 
					  GetRensou(pRensou, REFERENCE_URL_ENTRY));
	}
	/* إåʸδ֤˶ */
	putc('\n', fp_out);
	
	/* ʸ */
	curpos = GetRensou(pRensou, CONTENTS_ENTRY);
	WriteArticle(curpos, fp_out);
}
/*
 * WriteMesFile: åե򥪡ץ󤷤ƽ񤭹
 */
void WriteMesFile(pRensou)
	CONST RENSOU *pRensou;
{
	int pid;
	int fd[2];
	
	sprintf(g_szMesName, "%s/%08d", MES_DIR_NAME, g_iMesNum);
	
	if (pipe(fd) == ERR) {
		EndHtml();
		quitting();
		exit(EXIT_FAILURE);
	}
	if ((pid = fork()) == 0) {
		FILE *fp_in, *fmes;
		/* åեΥץ */
		if ((fmes = fopen(g_szMesName, "w")) == NULL){
			exit(EXIT_FAILURE);
		}
		close(fd[1]);
		if ((fp_in = fdopen(fd[0], "r")) == NULL) {
			exit(EXIT_FAILURE);
		}
		
		nkfSetOutputCode(NKF_EUC);
		nkfAssumeHankakuKana(TRUE);
		nkfSetDelCR();
		nkfSetBufferMode(FALSE);
		nkfToFile(fp_in, fmes);
		
		fclose(fmes);
		fclose(fp_in);
		exit(EXIT_SUCCESS);
	} else if (pid > 0) {
		FILE *fp_out;
		close(fd[0]);
		if ((fp_out = fdopen(fd[1], "w")) == NULL) {
			ErrorHtml(ERROR_FACE, "ץ̿ǼԤޤ");
			EndHtml();
			quitting();
			exit(EXIT_FAILURE);
		}
		WriteRowText(pRensou, fp_out);
		fclose(fp_out);
	} else {
		ErrorHtml(ERROR_FACE,
				  "fork() Ԥޤ");
		EndHtml();
		quitting();
		exit(EXIT_FAILURE);
	}
	
}
/*
 * GetCount: count ե뤫顢åֹ
 */
int GetCount()
{
	int fdcount;
	ssize_t read_count;
	char szCount[16];
	
	if ((fdcount = WRLockFile(MES_COUNT_FILE_NAME)) != ERR){
		if ((read_count = read(fdcount, szCount, 16)) == ERR){
			ErrorHtml(ERROR_FACE,
					  "å񤭹ޤ줿ե򳫤ޤǤ");
			EndHtml();
			UnlockFiles();
			quitting();
			exit(EXIT_FAILURE);
		} else if (read_count > 0) {
			g_iMesNum = atoi(szCount);
		} else {
			g_iMesNum = 0;
		}
	}
	return fdcount;
}
/*
 * SetCount: count եˡåֹ񤭹
 */
void SetCount(fdcount)
	int fdcount;
{
	char sz[8+1];
	sprintf(sz, "%d\n", g_iMesNum);
	if (lseek(fdcount, 0, SEEK_SET) == ERR) {
		ErrorHtml(ERROR_FACE, "count եؤΥԤޤ");
		UnlockFiles();
		quitting();
		exit(EXIT_FAILURE);
	}
	if (write(fdcount, sz, strlen(sz)+1) == ERR) {
		ErrorHtml(ERROR_FACE, "count եؤν񤭹ߤԤޤ");
		UnlockFiles();
		quitting();
		exit(EXIT_FAILURE);
	}
	
	/* ȥեΥå*/
	UnlockFile(fdcount);
}

/*
 * WriteDelKey: ե˽񤭹ࡣ
 */
BOOL WriteDelkey(szDelKey)
	CONST char *szDelKey;
{
	unsigned char digest[16];
	char szLine[16+3*16+1];
	int fd;
	int i;

	if (!hashMD5(g_iMesNum, szDelKey, digest))
		return FALSE;

	sprintf(szLine, "%08d =", g_iMesNum);
	for (i = 0; i < 16; i++) 
		sprintf(szLine, "%s %x", szLine, digest[i]);
	sprintf(szLine, "%s\n", szLine);
	
	/* Ǽեå */
	fd = LockFile(DELKEY_FILE_NAME, FALSE, TRUE);
	
	write(fd, szLine, strlen(szLine));

	/* å */
	UnlockFile(fd);
	
	return TRUE;
}
/* 
 *	SendReport: ǿ LOG ̤ɽ 
 */
void SendReport()
{
	FILE *fp;
	int stat_loc;

	printf("<p><img src=\"../%s\" alt=\"(^o^)\" width=\"40\" height=\"30\">",
		   SUCCESS_FACE);
	puts("<strong>㤤ޤ </strong></p>");

	/* ҥץʽ񤭹ߡˤνλԤäơեΥץ */
	wait(&stat_loc);
	if ((fp = fopen(g_szMesName, "r")) != NULL) {
		PrintArticle(g_iMesNum, stdout, fp);
		fclose(fp);
	}
	
	printf("<a href=\"%s\"></a>\n", READ_PATH);
	
	fflush(stdout);
}
/*
 * GetUserData: եɤʸݥ󥿤֤
 */
CONST char *GetUserData(szField, szCookie) 
	CONST char *szField, *szCookie;
{
	if (strcmp(szField, "") == 0){
		if (g_bUseCookie) {
			if (szCookie != NULL) {
				if (strcmp(szCookie, "") == 0) {
					return NULL;
				} else {
					return szCookie;
				}
			}
		}
		return NULL;
	}
	return szField;
}
/*
 * isSpace : Ⱦor ѥڡǹƤʸǤ뤫ɤ
 */
BOOL isSpace(sz)
	CONST char *sz;
{
	if (sz == NULL)
		return FALSE;
	while (*sz != '\0') {
		if (*sz == ' ' || *sz == '\t') {
			sz++;
			continue;
		} else if (strncmp(sz, "", 2) == 0){
			sz += 2;
			continue;
		}
		return FALSE;
	}
	return TRUE;
}
/*
 * Fill3Datas: ̾e-mail ɥ쥹
 *			   եफå롣
 */
BOOL Fill3Datas()
{
	/* եबƤʤäν */
	g_szAddress = GetRensou(g_FormDatas, ADDRESS_ENTRY);
	if (g_szAddress == NULL || isSpace(g_szAddress)){
#if NEED_EMAIL_ADDRESS
		StartHtml("ꤤ", READ_PATH, REFRESH_SEC);
		KuhakuUmeteHtml(PEKORI_FACE, "Żҥ᡼륢ɥ쥹");
		return FALSE;
#endif
	}
	g_szName = GetRensou(g_FormDatas, NAME_ENTRY);
	if (g_szName == NULL || isSpace(g_szName)) {
		StartHtml("ꤤ", READ_PATH, REFRESH_SEC);
		KuhakuUmeteHtml(PEKORI_FACE, "̾");
		return FALSE;
	}
	g_szDelKey = GetRensou(g_FormDatas, DELKEY_ENTRY);
	if (g_szDelKey == NULL || isSpace(g_szDelKey)) {
		StartHtml("ꤤ", READ_PATH, REFRESH_SEC);
		KuhakuUmeteHtml(PEKORI_FACE, "");
		return FALSE;
	}
	return TRUE;
}
/*
 * submit_mes : åν񤭹
 */
BOOL submit_mes()
{
	BOOL bSendCookie = FALSE;
	int fd_count;
	
	/* åȤɤ */
	if (GetRensou(g_FormDatas, COOKIE_ENTRY) == NULL) {
		g_bUseCookie = FALSE;
	} else {
		g_bUseCookie = TRUE;
	}
	/* Ȥɤ */
	if (GetRensou(g_FormDatas, TAG_ENTRY) == NULL) {
		g_bUseTag = FALSE;
	} else {
		g_bUseTag = TRUE;
	}
	/* ̾᡼륢ɥ쥹 */
	if (Fill3Datas(g_FormDatas) == FALSE) {
		return FALSE;
	}
	/* åإå */
	if (g_bUseCookie) {
		bSendCookie = SendCookies();
	}
	/* 顢HTML Ƿ */
	StartHtml("", READ_PATH, REFRESH_SEC);
	fflush(stdout);
	/* å˼Ԥ */
	if (g_bUseCookie && !bSendCookie) {
		printf("å˼Ԥޤ񤭹ߤ³Ԥޤ<br>");
	}
	/* ȥեΤåɤ߹ */
	fd_count = GetCount();
	g_iMesNum++;
#ifdef DEBUG
	puts("ȥե뤫ɤ߹<br>");
	fflush(stdout);
#endif
	
	/* ν񤭹 */
	if (!WriteDelkey(g_szDelKey)){
		ErrorHtml(ERROR_FACE, "񤭹ߤ˼Ԥޤ<br>");
		return FALSE;
	}
#ifdef DEBUG
	puts("񤭹<br>");
	fflush(stdout);
#endif
	
	/* ե˽񤭽Ф */
	WriteMesFile(g_FormDatas);
#ifdef DEBUG
	puts("񤭹<br>");
	fflush(stdout);
#endif
	/* ȥե˽񤭹 */
	SetCount(fd_count);
	
	/* ǿΥ */
	SendReport();
	return TRUE;
}
#if CHECK_OUTSIDE_FORM
/*
 * DotEraser : ѥ ".", ".." Ѵ롣
 */
char *DotEraser(szURL)
	char *szURL;
{
	char *pchild, *pparent;

	if ((pchild = strstr(szURL, "/../")) != NULL) {
		*pchild = '\0';
		if ((pparent = strrchr(szURL, '/')) == NULL) {
			return NULL;
		}
		pchild += 3;
		if (strmove(pparent, pchild) == NULL)
			return NULL;
		return szURL;
	} else if ((pchild = strstr(szURL, "/./")) != NULL) {
		pparent = pchild;
		pchild += 2;
		if (strmove(pparent, pchild) == NULL)
			return NULL;
		return szURL;
	} else {
		return NULL;
	}
}
/*
 * CheckReferer : եफΥɤå
 * HTTP_REFERER == http://SRV_NAME+SCRIPT_NAME+PATH_INFO
 */
BOOL CheckReferer(szRefPageName)
	char *szRefPageName;
{
	CONST char *szRef, *szSrvName, *szScriptName, *szServerPort;
	CONST char *szReadPath = READ_PATH, *szFollowPath = FOLLOW_PATH;
	char *szRefDecode, *szAbsPath;
	CONST char **aliases;
	char *pSlash;
	int iRefPageNameLen = 0;

	iRefPageNameLen = (szRefPageName != NULL) ? strlen(szRefPageName) : 0;
	
	if ((szRef = getenv("HTTP_REFERER")) == NULL) {
		return FALSE;
	}
	if (strncmp(szRef, HTTP_SCHEME, strlen(HTTP_SCHEME)) != 0) {
		return FALSE;
	}
	szRef += strlen(HTTP_SCHEME);
	szRefDecode = (char *)malloc(strlen(szRef)+iRefPageNameLen+1);
	if (szRefDecode == NULL) {
		return FALSE;
	}
	URLDecode(szRefDecode, szRef);

#if GET_ENV_SERVER_NAME
	if ((szSrvName = getenv("SERVER_NAME")) == NULL) {
		return FALSE;
	}
#else
	szSrvName = HTTP_SERVER_NAME;
#endif /* GET_ENV_SERVER_NAME */
#if GET_ENV_URL_PATH
	if ((szScriptName = getenv("SCRIPT_NAME")) == NULL) {
		return FALSE;
	}
#else
	szScriptName = URL_PATH;
#endif /* GET_ENV_URL_PATH */
	szAbsPath = (char *)malloc(strlen(szScriptName)+
							   iRefPageNameLen+
							   max(strlen(szReadPath),
								   strlen(szFollowPath))+1);
	if (szAbsPath == NULL) {
		free(szRefDecode);
		return FALSE;
	}
	strcpy(szAbsPath, szScriptName);
	
	if (szRefPageName != NULL) {
		strcpy(strrchr(szAbsPath, '/')+1, szRefPageName);
	} else {
		if (*szReadPath != '/')
			strcat(szAbsPath, "/");
		strcat(szAbsPath, szReadPath);
	}
	while (DotEraser(szAbsPath) != NULL)
		;
	if ((szServerPort = getenv("SERVER_PORT")) == NULL) {
		free(szRefDecode);
		free(szAbsPath);
		return FALSE;
	}
	if (exam_url(szRefDecode, szSrvName, szAbsPath, szServerPort)) {
		free(szRefDecode);
		free(szAbsPath);
		return TRUE;
	}
	if (szRefPageName == NULL) {
		strcpy(szAbsPath, szScriptName);
		if (*szReadPath != '/')
			strcat(szAbsPath, "/");
		strcat(szAbsPath, szFollowPath);
		if (exam_url(szRefDecode, szSrvName, szAbsPath, szServerPort)) {
			free(szRefDecode);
			free(szAbsPath);
			return TRUE;
		}
	}
	StartHtml("եफν񤭹ߤǧޤ",
			  READ_PATH, REFRESH_SEC*3);
	ErrorHtml(ERROR_FACE, "եफν񤭹ߤǧޤ");
	printf("<p> URL ν񤭹ߤǤȽǤޤhttp://%s</p>",
		   szRefDecode);
	printf("<p>ʲURL ǽ񤭹Ǥ</p>");
	if ((pSlash = strrchr(szAbsPath, '/')) != NULL) {
		*pSlash = '\0';
	}
	aliases = HostNameAliases(szSrvName);
	do {
		printf("<a href=\"http://%s%s\">", szSrvName, szAbsPath);
		printf("http://%s%s/%s, or /%s</a><br>",
			   szSrvName, szAbsPath, READ_PATH, FOLLOW_PATH);
	} while ((szSrvName = *aliases++) != NULL);

	free(szRefDecode);
	free(szAbsPath);
	return FALSE;
}
#endif /* CHECK_OUTSIDE_FORM */

/*
 *	main() ؿ 
 */
int main(argc, argv)
	int argc;
	char *argv[];
{
	char *szQueryString = NULL;
	char *szMode = NULL, *szPath = NULL;

	signal(SIGINT, quit);
	signal(SIGQUIT, quit);
	signal(SIGTERM, quit);
	signal(SIGPIPE, quit);
	
	/* ֤μ */
	gettimeofday(&g_date, NULL);

	g_FormDatas->pszEntry = NULL;

	/* « */
	printf("Content-type:text/html;charset=euc-jp\n");
	fflush(stdout);
	
	g_szCGIName = argv[0];

	if ((szPath = getenv("PATH_INFO")) == NULL) {
		char url[256], face[256];
		sprintf(url, "%s/%s", g_szCGIName, READ_PATH);
		StartHtml("Ԥ", url, REFRESH_SEC);
		printf("<h3><img src=\"%s\" alt=\"_(._.)_\" width=\"40\" height=\"30\">Ԥ</h3>", PEKORI_FACE);
		printf("<p>Ф餯Ƥưʤϡ<a href=\"%s\"></a>", url);
		EndHtml();
		return 0;
	}
	if (*szPath == '/') {
		szPath++;
	}
	/* CONTENT_LENGTH ̣ */
	g_iContentLength = GetContentLength();
	if (g_iContentLength == 0) {
		catmes(TRUE, FALSE);
		return 0;
	} 
#if CONTENT_LENGTH != 0
	else if (g_iContentLength > CONTENT_LENGTH_MAX*1024) {
		StartHtml("󤢤ν񤭹ߤ¥Сޤ",
				  READ_PATH, REFRESH_SEC);
		OnegaiHtml(PEKORI_FACE, "󤢤ν񤭹ߤ¥򡢥Сޤ",
				   "񤭹ޤ줿ʸ¿뤿ᡢͤ񤭹ߤĤޤǤޤʸ򾯤ʤơ⤦Ƥ");
		EndHtml();
		return 0;
	}
#endif /* CONTENT_LENGTH_MAX */

	/* եफϤ줿ǡϢ˳Ǽ */
	szQueryString = GetFromForm(g_iContentLength);
	if (szQueryString == NULL) {
		catmes(TRUE, FALSE);
		return 0;
	} else {
		KakunouRensou(g_FormDatas, szQueryString, ENTRY_NUM);
		TreatTokusyuMoji(g_FormDatas, g_iContentLength);
		free(szQueryString);
	}
	/* PATH_INFO ˤưѲ
	   READ_PATH: åɽ
	   WRITE_PATH: å񤭹
	   DEL_PATH: å
	*/
	szMode = GetRensou(g_FormDatas, MODE_ENTRY);
	if (strcmp(szPath, READ_PATH) == 0) {
		catmes(FALSE, FALSE);
	} else if (strcmp(szPath, WRITE_PATH) == 0) {
		if (CheckReferer(NULL)) {
			submit_mes();
		}
	} else if (strcmp(szPath, DEL_PATH) == 0) {
		if (CheckReferer(NULL)) {
			delmes();
		}
	} else if (strcmp(szPath, FOLLOW_PATH) == 0) {
		catmes(TRUE, TRUE);
	} else if (strcmp(szPath, ADMIN_DEL_PATH) == 0) {
		if (strcmp(szMode, "admindel") == 0) {
			admindel();
		}
	} else {
		catmes(TRUE, FALSE);
	}
	quitting();
	return 0;
}
