/*
 * rensou.c : Ϣι¤Τ갷
 * Copyright (C) 1998 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>

#include "mytypes.h"
#include "rensou.h"
#include "htmlio.h"

static unsigned char g_HexTable[0x100];

/*
 * GetContentLength: եफ줿ǡΥ
 */
int GetContentLength()
{
	char *pszLength;
	
	pszLength = getenv("CONTENT_LENGTH");
	if (pszLength == NULL) {
		return 0;
	}
	return atoi(pszLength);
}
/*
 * GetFromForm: ϥեफǡ
 */
char *GetFromForm(iContLen)
	int iContLen;
{
	char *pszQueryString, *pszCurPoint;
	/* Ķѿ CONTENT_LENGTH 顢ʸĹơ
		Хѿ(g_iContentLength )˳Ǽ */
	/* ɸϤ顢ʸǼ */
	if ((pszQueryString = (char *)malloc(iContLen+1)) == NULL) {
		return NULL;
	}
	pszCurPoint = pszQueryString;
	while (iContLen-- > 0) {
		if ((*pszCurPoint++ = getchar()) == EOF)
			break;
	}
	*pszCurPoint = '\0';
	return pszQueryString;
}
/*
 *  KakunouRensou: Ϣ˥ǡǼ
 */
int KakunouRensou(pRensou, pszQueryString, iEntryNum)
	RENSOU *pRensou;
	char *pszQueryString;
	int iEntryNum;
{
	RENSOU *pCurRensou = pRensou;
	char *pszCurPos;
	pszCurPos = pszQueryString;
	
	if ((pCurRensou->pszEntry = strtok(pszQueryString, " &;")) != NULL) {
		pCurRensou++;
		while (pCurRensou < pRensou+iEntryNum-1
				&& (pCurRensou->pszEntry = strtok(NULL, " &;")) != NULL) {
			pCurRensou++;
		}
		pCurRensou->pszEntry = NULL;
	} else {
		pRensou->pszEntry = pszQueryString;
		(pRensou+1)->pszEntry = NULL;
	}
	
	pCurRensou = pRensou;

	while (pCurRensou->pszEntry != NULL) {
		strtok(pCurRensou->pszEntry, "=");
		
		if ((pCurRensou->pszData = strtok(NULL, "=")) == NULL) {
			pCurRensou->pszData
				= pCurRensou->pszEntry+strlen(pCurRensou->pszEntry);
		}
		pCurRensou++;
		
	}

	return TRUE;
}
/*
 * URLEncode: ʸ URL 󥳡
 */
char *URLEncode(after, before)
	char *after;
	CONST char *before;
{
	unsigned char c, *after_head = (unsigned char*)after;
	if (after == NULL || before == NULL) {
		return NULL;
	}
	while ((c = *before++) != '\0') {
		if (isalnum(c)
			|| c == '$' || c == '-' || c == '_' || c == '.'
			|| c == '!' || c == '*' || c == '\'' || c == '('
			|| c == ')' || c == ',') {
			*after++ = c;
		} else {
			char hex[4];
			sprintf(hex, "%%%02X", c);
			strcpy(after, hex);
			after += 3;
		}
	}
	*after = '\0';
	
	return (char *)after_head;
}
/*
 * InitTable : Initialize g_HexTable
 */
void InitTable()
{
	static BOOL first_call = TRUE;
	if (first_call == TRUE) {
		int i;
		for (i = 0; i < 0x100; i++) {
			g_HexTable[i] = 0;
		}
		g_HexTable['0'] = 0;
		g_HexTable['1'] = 1;
		g_HexTable['2'] = 2;
		g_HexTable['3'] = 3;
		g_HexTable['4'] = 4;
		g_HexTable['5'] = 5;
		g_HexTable['6'] = 6;
		g_HexTable['7'] = 7;
		g_HexTable['8'] = 8;
		g_HexTable['9'] = 9;
		g_HexTable['a'] = g_HexTable['A'] = 0xA;
		g_HexTable['b'] = g_HexTable['B'] = 0xB;
		g_HexTable['c'] = g_HexTable['C'] = 0xC;
		g_HexTable['d'] = g_HexTable['D'] = 0xD;
		g_HexTable['e'] = g_HexTable['E'] = 0xE;
		g_HexTable['f'] = g_HexTable['F'] = 0xF;
		first_call = FALSE;
	}
}
/*
 * URLDecode : ʸ URL ǥ
 */
char *URLDecode(after, before)
	char *after;
	CONST char *before;
{
	char *after_head = after;

	InitTable();

	if (before == NULL)
		return NULL;

	while (*before != '\0') {
		switch (*before) {
			case '%':
				*after++ = (char)(((unsigned char)g_HexTable[(int)*(before+1)]<<4)
					+g_HexTable[(int)*(before+2)]);
				before += 3;
				break;
			case '+':
				*after++ = ' ';
				before++;
				break;
			case ' ':
				before++;
				break;
			default:
				*after++ = *before++;
				break;
		}
	}
	*after = '\0';
	
	return after_head;
}
/*
 *  TreatTokusyuMoji: üʸѴ
 */
int TreatTokusyuMoji(pRensou, iContentLength)
	RENSOU *pRensou;
	int iContentLength;
{
	while (pRensou->pszEntry != NULL) {
		char *pszBuffer;
		pRensou->pszEntry = strdup(pRensou->pszEntry);
		pszBuffer = (char *)malloc(iContentLength+1);
		URLDecode(pszBuffer, pRensou->pszData);
		if (*pszBuffer != '\0') {
			pRensou->pszData = strdup(pszBuffer);
		} else {
			pRensou->pszData = strdup("");
		}
		pRensou++;
		free(pszBuffer);
	}
	return TRUE;
}
/*
 *  GetRensou: Ϣ󤫤顢ʸ˴Ϣդ줿Ǥ
 */
char *GetRensou(pRensou, pszEntry)
	CONST RENSOU *pRensou;
	CONST char *pszEntry;
{
	while(pRensou->pszEntry != NULL) {
		if (strcmp(pRensou->pszEntry, pszEntry) == 0){
			return pRensou->pszData;
		}
		pRensou++;
	}
	return NULL;
}
/*
 *  FreeRensou: Ϣ 
 */
void FreeRensou(pRensou, iEntryNum)
	RENSOU *pRensou;
	int iEntryNum;
{
	RENSOU *pCurRensou = pRensou;
	while (pCurRensou->pszEntry != NULL && pCurRensou < pRensou+iEntryNum-1) {
		free(pCurRensou->pszEntry);
		free(pCurRensou->pszData);
		pCurRensou++;
	}
}
