/*
 * util.c : ėp[eBeB[֐B
 * $Revision: 1.6.1.1 $
 * $Date: 1999/03/02 12:29:34 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <fcntl.h>

#include "mytypes.h"
#include "util.h"

#define TIME_FIELD_SIZE 64

/*
 * IPtoHostName : IP t
 */
void IPtoHostName(dst, ipaddr)
	char *dst;
	CONST char *ipaddr;
{
	struct hostent *hent;
	unsigned long sin_addr;
	
	sin_addr = inet_addr(ipaddr);
	hent = gethostbyaddr((char *)&sin_addr,
						 sizeof(sin_addr), AF_INET);
	if (hent == NULL) {
		strcpy(dst, ipaddr);
		return;
	}
	strcpy(dst, hent->h_name);
}
/*
 * HostNameAliases: 
 */
CONST char **HostNameAliases(hostname)
	CONST char *hostname;
{
	struct hostent *hent;
	if ((hent = gethostbyname(hostname)) == NULL) {
		return NULL;
	}
	return (CONST char **)hent->h_aliases;
}
/*
 * exam_url : URL ̃`FbN
 */
BOOL exam_url(url, hostname, scriptname, port)
	CONST char *url, *hostname, *scriptname, *port;
{
	CONST char **aliases, *onehost = hostname;
	char *correct_url;

	aliases = HostNameAliases(hostname);
	do {
		correct_url = (char *)malloc(strlen(onehost)+
							 strlen(scriptname)+
							 strlen(port)+1);
		if (correct_url == NULL) {
			free(correct_url);
			return FALSE;
		}
		if (strcmp(port, "80") == 0) {
			sprintf(correct_url, "%s%s", onehost, scriptname);
			if (strcmp(url, correct_url) == 0) {
				free(correct_url);
				return TRUE;
			}
		}
		sprintf(correct_url, "%s:%s%s", onehost, port, scriptname);
		if (strcmp(url, correct_url) == 0) {
			free(correct_url);
			return TRUE;
		}
		free(correct_url);
	} while ((onehost = *aliases++) != NULL);
	return FALSE;
}
/*
 * strmove : memmove (ANSI) ̕
 */
char *strmove(dst, src)
	char *dst;
	CONST char *src;
{
	char *buf;
	if ((buf = (char *)malloc(strlen(src)+1)) == NULL) {
		return NULL;
	}
	strcpy(buf, src);
	strcpy(dst, buf);
	free(buf);
	return dst;
}
/*
 * asctime_for_cookie : Cookie p̓̕\
 */
CONST char *asctime_for_cookie(tp)
	CONST time_t *tp;
{
	static char szAscTime[TIME_FIELD_SIZE];
	strftime(szAscTime, TIME_FIELD_SIZE, "%A, %d-%b-%Y %H:%M:%S GMT", gmtime(tp));
	return szAscTime;
}
/*
 * asctime_rfc1123: RFC1123 ɂ̂Ƃ\
 */
CONST char *asctime_rfc1123(tp)
	CONST time_t *tp;
{
	static char szAscTime[TIME_FIELD_SIZE];
	strftime(szAscTime, TIME_FIELD_SIZE, "%a, %d %b %Y %H:%M:%S GMT", gmtime(tp));
	return szAscTime;
}
void DestroyCache(cache)
	CONST char *cache;
{
	int fd;
	fd = open(cache, O_CREAT | O_TRUNC | O_WRONLY);
	close(fd);
}
