/*
 * write_to.c : SMTP Фľäơ᡼
 * $Revision: 1.6 $
 * $Date: 1999/02/22 04:49:16 $
 * Copyright (C) 1998-1999 Suzuki Mitsuhiro All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

unsigned long host2sin_addr(hostname)
	char *hostname;
{
	struct hostent *hent;
	hent = gethostbyname(hostname);
	if (hent != NULL) {
		long *addr;
		addr = (long *)hent->h_addr;
		return *addr;
	}
	return inet_addr(hostname);
}
int getsmtpport()
{
	struct servent *sent;
	sent = getservbyname("smtp", "tcp");
	return sent->s_port;
}
int detect_reply_num(reply, nums)
    char *reply, *nums;
{
	char *dup_nums, *curpos;

	printf("%s", reply);
	dup_nums = strdup(nums);
	if ((curpos = strtok(dup_nums, " ")) == NULL) {
		free(dup_nums);
		return 1;
	}
	while (1) {
		if (strncmp(reply, curpos, strlen(curpos)) == 0) {
			break;
		}
		if ((curpos = strtok(NULL, " ")) == NULL) {
			free(dup_nums);
			return 1;
		}
	}
	free(dup_nums);
	return 0;
}
int examreply(fp, success, fail_or_error)
	FILE *fp;
	char *success, *fail_or_error;
{
	char buff[128];
	
	buff[sizeof (buff)-1] = '\0';
	while (fgets(buff, sizeof (buff)-1, fp) != NULL) {
		if (detect_reply_num(buff, success) == 0) {
			return 0;
		} else if (detect_reply_num(buff, fail_or_error) == 0) {
			break;
		}
	}
	fclose(fp);
	return 1;
}
/*
 * write_to : SMTP ǥФäơ᡼
 */
FILE *write_to(to, from, mail_srv)
	char *to, *from, *mail_srv;
{
	int sockdsc;
	struct sockaddr_in sockadd;
	int retry = 0;
	FILE *fp_socket = NULL;
	unsigned long sin_addr;
	/*char myhostname[MAXHOSTNAMELEN];*/

	/* åȺ */
	if ((sockdsc = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
		return NULL;
	}
	sin_addr = host2sin_addr(mail_srv);
	memcpy(&sockadd.sin_addr, &sin_addr, sizeof (sin_addr));
	sockadd.sin_port = getsmtpport();
	sockadd.sin_family = AF_INET;
	while (connect(sockdsc,
				   (struct sockaddr*)&sockadd,
				   sizeof (sockadd))
		   != 0) {
		if (retry > 10)
			return NULL;
		sleep(1);
		retry++;
	}
	fp_socket = fdopen(sockdsc, "r+");
	while (examreply(fp_socket, "220", "421") != 0)
		;
	fseek(fp_socket, 0, SEEK_END);
	/*  */
	fprintf(fp_socket, "MAIL FROM:<%s>\r\n", from);
	fseek(fp_socket, 0, SEEK_END);
	if (examreply(fp_socket, "250",
				  "552 451 452 500 501 421") != 0) {
		return NULL;
	}
	/* ɤ뤫 */
	fseek(fp_socket, 0, SEEK_END);
	fprintf(fp_socket, "RCPT TO:<%s>\r\n", to);
	fseek(fp_socket, 0, SEEK_END);
	if (examreply(fp_socket, "250 251",
				  "550 551 552 553 450 451 452 500 501 503 421") != 0) {
		return NULL;
	}
	/* ʸ */
	fseek(fp_socket, 0, SEEK_END);
	fputs("DATA \r\n", fp_socket);
	fseek(fp_socket, 0, SEEK_END);
	if (examreply(fp_socket, "354",
				  "451 554 500 501 504 421") != 0) {
		return NULL;
	}
	fseek(fp_socket, 0, SEEK_END);
	fflush(fp_socket);
	return fp_socket;
}
int quit_writting(fp)
	FILE *fp;
{
	fseek(fp, 0, SEEK_END);
	fputs("\r\n.\r\n", fp);
	fseek(fp, 0, SEEK_END);
	if (examreply(fp, "250", "552 554 451 452") != 0) {
		return 1;
	}
	/* λ */
	fseek(fp, 0, SEEK_END);
	fputs("QUIT\r\n", fp);
	fseek(fp, 0, SEEK_END);
	if (examreply(fp, "221", "500") != 0) {
		return 1;
	}
	fclose(fp);
	return 0;
}
